Bug 1416565 - [Docs][Networking] Document mitigation for microversion issues in device role tagging
Summary: [Docs][Networking] Document mitigation for microversion issues in device role...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat OpenStack
Classification: Red Hat
Component: documentation
Version: 10.0 (Newton)
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: async
: 10.0 (Newton)
Assignee: Martin Lopes
QA Contact: Dan Macpherson
URL:
Whiteboard:
Depends On: 1417686 1436266
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-25 20:19 UTC by Stephen Gordon
Modified: 2020-12-21 19:37 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-01 02:33:09 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Launchpad 1658571 0 None None None 2017-01-25 20:19:59 UTC

Description Stephen Gordon 2017-01-25 20:19:53 UTC
Cloned from launchpad bug 1658571.

Description:

Device tagging support was added in microversion 2.32, as for
ports:
http://git.openstack.org/cgit/openstack/nova/tree/nova/api/openstack/compute/schemas/servers.py#n76
but in latter microversion 2.37 accidentally removed it:
http://git.openstack.org/cgit/openstack/nova/tree/nova/api/openstack/compute/schemas/servers.py#n82

And for bdms:
the schema is added by
https://github.com/openstack/nova/blob/master/nova/api/openstack/compute/block_device_mapping.py#L76
and it will only work for microversion 2.32

So this function is only usable from microversion 2.32 to 2.37 for
ports and only for 2.32 for bdms.

we should fix it and backport to Newton.

Specification URL (additional information):

https://bugs.launchpad.net/nova/+bug/1658571

Comment 1 Stephen Gordon 2017-01-25 20:40:31 UTC
Under Bug # 1188175 (among others) we added a feature called device role tagging in Red Hat OpenStack Platform 10. This is mentioned in the release notes here:

https://access.redhat.com/documentation/en/red-hat-openstack-platform/10/paged/release-notes/chapter-3-release-information

It was also covered in the networking guide here:

https://access.redhat.com/documentation/en/red-hat-openstack-platform/10/single/networking-guide/#use-tagging

This feature was added in microversion 2.32 of the Nova API (awesome!) for both block devices and network ports (awesome!) *but*

- for block devices it turns out it *only* works in 2.32
- for ports due to a later change in microversion 2.37 it *only* works in microversions 2.32 to 2.37

As part of the gift that keeps on giving, the fix for this is - you guessed it - a new microversion! So we can't actually backport it, instead we need to confirm given an OOTB RHOSP 10 install what microversion are the client and server negotiating to and based on the results of this we need to document:

- What if any action is required to work around this issue and still use the feature (e.g. pin the client to 2.32).
- Symptoms to look out for to determine if such mitigation is needed now or in the future (e.g. if we later upgrade the client it may become necessary for a user to pin the microversion when they did not in the past).

Setting needinfo on Artom as the relevant SME to review the above and provide any further context.

Comment 2 Artom Lifshitz 2017-02-17 11:54:29 UTC
Good summary of the issue by Steve.

A few things to add:

This will go away in RHOS11, since the new microversion 2.42 that fixes all this mess merged just in time for Ocata upstream.

There's a downstream-only hack in progress [1] to python-novaclient (and *not* openstackclient) to make it work around this issue as much as it can. Once that's merged, the result should be that the issue will become invisible when using the RHOS novaclient, except when the user requests block device tagging *and* the automatic network feature introduced in 2.37. Those are mutually exclusive, and nothing can be done until version 2.42 arrives in RHOS11.

[1] https://code.engineering.redhat.com/gerrit/#/c/96540/

Comment 3 Artom Lifshitz 2017-03-03 20:07:29 UTC
With the fix upstream merged to stable/newton [1], this will be fixed next time the RHOS10 python-openstackclient is rebased from upstream.

[1] https://review.openstack.org/#/c/429772/

Comment 4 Artom Lifshitz 2017-03-03 20:09:28 UTC
Ignore comment #3, it was meant for a different bug.

Comment 5 Lucy Bopf 2017-05-26 05:44:18 UTC
Assigning to Martin for review.

Comment 6 Martin Lopes 2017-05-31 03:46:32 UTC
Working on draft. Note that the dev bug is still in a QA state: BZ#1436266

Comment 17 Dan Macpherson 2017-12-01 02:33:09 UTC
Sorry for the delay on peer reviewing this item. LGTM!


Note You need to log in before you can comment on or make changes to this bug.